/* PickerWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from PickerWindow.vala, do not modify */

/*
* Copyright (c) 2017 Ronny Dobra (https://github.com/RonnyDo/ColorPicker)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Ronny Dobra <ronnydobra at arcor dot de>
* Inspired by: https://github.com/stuartlangridge/ColourPicker/
*/

#include <granite.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>

#define SPICE_PICKER_WINDOW_dark_border_color_string "#333333"
#define SPICE_PICKER_WINDOW_bright_border_color_string "#FFFFFF"
#define SPICE_PICKER_WINDOW_SNAPSIZE 31
#define SPICE_PICKER_WINDOW_SHADOW_WIDTH 15
#define SPICE_PICKER_WINDOW_MAX_ZOOM_LEVEL 7
#define SPICE_PICKER_WINDOW_MIN_ZOOM_LEVEL 2
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SPICE_TYPE_PICKER_WINDOW (spice_picker_window_get_type ())
#define SPICE_PICKER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPICE_TYPE_PICKER_WINDOW, SpicePickerWindow))
#define SPICE_PICKER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SPICE_TYPE_PICKER_WINDOW, SpicePickerWindowClass))
#define SPICE_IS_PICKER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPICE_TYPE_PICKER_WINDOW))
#define SPICE_IS_PICKER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPICE_TYPE_PICKER_WINDOW))
#define SPICE_PICKER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SPICE_TYPE_PICKER_WINDOW, SpicePickerWindowClass))

typedef struct _SpicePickerWindow SpicePickerWindow;
typedef struct _SpicePickerWindowClass SpicePickerWindowClass;
typedef struct _SpicePickerWindowPrivate SpicePickerWindowPrivate;
enum  {
	SPICE_PICKER_WINDOW_0_PROPERTY,
	SPICE_PICKER_WINDOW_ZOOMLEVEL_PROPERTY,
	SPICE_PICKER_WINDOW_NUM_PROPERTIES
};
static GParamSpec* spice_picker_window_properties[SPICE_PICKER_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GdkRectangle_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRectangle_free (var), NULL)))
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SPICE_PICKER_WINDOW_PICKED_SIGNAL,
	SPICE_PICKER_WINDOW_CANCELLED_SIGNAL,
	SPICE_PICKER_WINDOW_MOVED_SIGNAL,
	SPICE_PICKER_WINDOW_NUM_SIGNALS
};
static guint spice_picker_window_signals[SPICE_PICKER_WINDOW_NUM_SIGNALS] = {0};

#define TYPE_EXT_RGBA (ext_rgba_get_type ())
typedef GdkRGBA ExtRGBA;

struct _SpicePickerWindow {
	GraniteWidgetsCompositedWindow parent_instance;
	SpicePickerWindowPrivate * priv;
};

struct _SpicePickerWindowClass {
	GraniteWidgetsCompositedWindowClass parent_class;
};

struct _SpicePickerWindowPrivate {
	GdkRGBA dark_border_color;
	GdkRGBA bright_border_color;
	GdkCursor* magnifier;
};

static gint SpicePickerWindow_private_offset;
static gpointer spice_picker_window_parent_class = NULL;
static gint spice_picker_window__zoom_level;
static gint spice_picker_window__zoom_level = 2;

VALA_EXTERN GType spice_picker_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SpicePickerWindow, g_object_unref)
VALA_EXTERN SpicePickerWindow* spice_picker_window_new (void);
VALA_EXTERN SpicePickerWindow* spice_picker_window_construct (GType object_type);
static GdkRectangle* _vala_GdkRectangle_copy (GdkRectangle* self);
static void _vala_GdkRectangle_free (GdkRectangle* self);
static gboolean spice_picker_window_real_button_release_event (GtkWidget* base,
                                                        GdkEventButton* e);
VALA_EXTERN void spice_picker_window_get_color_at (SpicePickerWindow* self,
                                       gint x,
                                       gint y,
                                       GdkRGBA* result);
static gboolean spice_picker_window_real_draw (GtkWidget* base,
                                        cairo_t* cr);
static gboolean spice_picker_window_real_motion_notify_event (GtkWidget* base,
                                                       GdkEventMotion* e);
static void spice_picker_window_set_magnifier_cursor (SpicePickerWindow* self);
static gboolean spice_picker_window_real_scroll_event (GtkWidget* base,
                                                GdkEventScroll* e);
VALA_EXTERN gint spice_picker_window_get_zoomlevel (SpicePickerWindow* self);
VALA_EXTERN void spice_picker_window_set_zoomlevel (SpicePickerWindow* self,
                                        gint value);
VALA_EXTERN GdkPixbuf* spice_picker_window_snap (SpicePickerWindow* self,
                                     gint x,
                                     gint y,
                                     gint w,
                                     gint h);
static void _vala_GdkEvent_free (GdkEvent* self);
static gboolean spice_picker_window_real_key_press_event (GtkWidget* base,
                                                   GdkEventKey* e);
static void spice_picker_window_real_show_all (GtkWidget* base);
VALA_EXTERN void spice_picker_window_close (SpicePickerWindow* self);
static GObject * spice_picker_window_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void spice_picker_window_finalize (GObject * obj);
static GType spice_picker_window_get_type_once (void);
static void _vala_spice_picker_window_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_spice_picker_window_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
VALA_EXTERN GType ext_rgba_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ExtRGBA* ext_rgba_dup (const ExtRGBA* self);
VALA_EXTERN void ext_rgba_free (ExtRGBA* self);
VALA_EXTERN gchar* ext_rgba_to_css_rgb_string (ExtRGBA *self);

static inline gpointer
spice_picker_window_get_instance_private (SpicePickerWindow* self)
{
	return G_STRUCT_MEMBER_P (self, SpicePickerWindow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GdkRectangle*
_vala_GdkRectangle_copy (GdkRectangle* self)
{
	return g_boxed_copy (gdk_rectangle_get_type (), self);
}

static gpointer
__vala_GdkRectangle_copy0 (gpointer self)
{
	return self ? _vala_GdkRectangle_copy (self) : NULL;
}

static void
_vala_GdkRectangle_free (GdkRectangle* self)
{
	g_boxed_free (gdk_rectangle_get_type (), self);
}

SpicePickerWindow*
spice_picker_window_construct (GType object_type)
{
	SpicePickerWindow * self = NULL;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkRectangle* screens_rectangle = NULL;
	gint n_monitors = 0;
	GdkDisplay* _tmp2_;
	GdkRectangle* _tmp19_;
	GdkRectangle* _tmp20_;
	self = (SpicePickerWindow*) granite_widgets_composited_window_construct (object_type);
	gtk_window_stick ((GtkWindow*) self);
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
	gtk_window_set_skip_pager_hint ((GtkWindow*) self, TRUE);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	gdk_rgba_parse (&self->priv->dark_border_color, SPICE_PICKER_WINDOW_dark_border_color_string);
	gdk_rgba_parse (&self->priv->bright_border_color, SPICE_PICKER_WINDOW_bright_border_color_string);
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	display = _tmp1_;
	screens_rectangle = NULL;
	_tmp2_ = display;
	n_monitors = gdk_display_get_n_monitors (_tmp2_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				GdkMonitor* monitor = NULL;
				GdkDisplay* _tmp5_;
				GdkMonitor* _tmp6_;
				GdkMonitor* _tmp7_;
				GdkRectangle* _tmp8_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				if (!(i < n_monitors)) {
					break;
				}
				_tmp5_ = display;
				_tmp6_ = gdk_display_get_monitor (_tmp5_, i);
				_tmp7_ = _g_object_ref0 (_tmp6_);
				monitor = _tmp7_;
				_tmp8_ = screens_rectangle;
				if (_tmp8_ == NULL) {
					GdkMonitor* _tmp9_;
					GdkRectangle _tmp10_ = {0};
					GdkRectangle* _tmp11_;
					_tmp9_ = monitor;
					gdk_monitor_get_geometry (_tmp9_, &_tmp10_);
					_tmp11_ = __vala_GdkRectangle_copy0 (&_tmp10_);
					__vala_GdkRectangle_free0 (screens_rectangle);
					screens_rectangle = _tmp11_;
				} else {
					GdkRectangle rectangle = {0};
					GdkMonitor* _tmp12_;
					GdkRectangle _tmp13_ = {0};
					GdkRectangle* _tmp14_;
					GdkRectangle _tmp15_;
					GdkRectangle _tmp16_ = {0};
					GdkRectangle _tmp17_;
					GdkRectangle* _tmp18_;
					_tmp12_ = monitor;
					gdk_monitor_get_geometry (_tmp12_, &_tmp13_);
					rectangle = _tmp13_;
					_tmp14_ = screens_rectangle;
					_tmp15_ = rectangle;
					gdk_rectangle_union (_tmp14_, &_tmp15_, &_tmp16_);
					__vala_GdkRectangle_free0 (screens_rectangle);
					_tmp17_ = _tmp16_;
					_tmp18_ = __vala_GdkRectangle_copy0 (&_tmp17_);
					screens_rectangle = _tmp18_;
				}
				_g_object_unref0 (monitor);
			}
		}
	}
	_tmp19_ = screens_rectangle;
	_tmp20_ = screens_rectangle;
	gtk_window_set_default_size ((GtkWindow*) self, (*_tmp19_).width, (*_tmp20_).height);
	__vala_GdkRectangle_free0 (screens_rectangle);
	_g_object_unref0 (display);
	return self;
}

SpicePickerWindow*
spice_picker_window_new (void)
{
	return spice_picker_window_construct (SPICE_TYPE_PICKER_WINDOW);
}

static gboolean
spice_picker_window_real_button_release_event (GtkWidget* base,
                                               GdkEventButton* e)
{
	SpicePickerWindow * self;
	gboolean result;
	self = (SpicePickerWindow*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->button == ((guint) 1)) {
		GdkRGBA color = {0};
		GdkRGBA _tmp0_ = {0};
		GdkRGBA _tmp1_;
		spice_picker_window_get_color_at (self, (gint) e->x_root, (gint) e->y_root, &_tmp0_);
		color = _tmp0_;
		_tmp1_ = color;
		g_signal_emit (self, spice_picker_window_signals[SPICE_PICKER_WINDOW_PICKED_SIGNAL], 0, &_tmp1_);
	} else {
		if (e->button == ((guint) 3)) {
			g_signal_emit (self, spice_picker_window_signals[SPICE_PICKER_WINDOW_CANCELLED_SIGNAL], 0);
		}
	}
	result = TRUE;
	return result;
}

static gboolean
spice_picker_window_real_draw (GtkWidget* base,
                               cairo_t* cr)
{
	SpicePickerWindow * self;
	gboolean result;
	self = (SpicePickerWindow*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	result = FALSE;
	return result;
}

static gboolean
spice_picker_window_real_motion_notify_event (GtkWidget* base,
                                              GdkEventMotion* e)
{
	SpicePickerWindow * self;
	GdkRGBA color = {0};
	GdkRGBA _tmp0_ = {0};
	GdkRGBA _tmp1_;
	gboolean result;
	self = (SpicePickerWindow*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	spice_picker_window_get_color_at (self, (gint) e->x_root, (gint) e->y_root, &_tmp0_);
	color = _tmp0_;
	_tmp1_ = color;
	g_signal_emit (self, spice_picker_window_signals[SPICE_PICKER_WINDOW_MOVED_SIGNAL], 0, &_tmp1_);
	spice_picker_window_set_magnifier_cursor (self);
	result = TRUE;
	return result;
}

static gboolean
spice_picker_window_real_scroll_event (GtkWidget* base,
                                       GdkEventScroll* e)
{
	SpicePickerWindow * self;
	gboolean result;
	self = (SpicePickerWindow*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	switch (e->direction) {
		case GDK_SCROLL_UP:
		{
			gint _tmp0_;
			gint _tmp1_;
			_tmp0_ = spice_picker_window_get_zoomlevel (self);
			_tmp1_ = _tmp0_;
			spice_picker_window_set_zoomlevel (self, _tmp1_ + 1);
			break;
		}
		case GDK_SCROLL_DOWN:
		{
			gint _tmp2_;
			gint _tmp3_;
			_tmp2_ = spice_picker_window_get_zoomlevel (self);
			_tmp3_ = _tmp2_;
			spice_picker_window_set_zoomlevel (self, _tmp3_ - 1);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}

static void
_vala_GdkEvent_free (GdkEvent* self)
{
	g_boxed_free (gdk_event_get_type (), self);
}

static void
spice_picker_window_set_magnifier_cursor (SpicePickerWindow* self)
{
	GdkSeat* manager = NULL;
	GdkDisplay* _tmp0_;
	GdkSeat* _tmp1_;
	GdkSeat* _tmp2_;
	gint px = 0;
	gint py = 0;
	GdkSeat* _tmp3_;
	GdkDevice* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint radius = 0;
	gint _tmp7_;
	gint _tmp8_;
	GdkPixbuf* latest_pb = NULL;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* scaled_pb = NULL;
	GdkPixbuf* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GdkPixbuf* _tmp15_;
	cairo_surface_t* base_surface = NULL;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	cairo_surface_t* _tmp20_;
	cairo_t* base_context = NULL;
	cairo_surface_t* _tmp21_;
	cairo_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_t* _tmp24_;
	GdkPixbuf* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	cairo_t* _tmp28_;
	cairo_t* _tmp29_;
	gdouble shadow_alpha = 0.0;
	cairo_t* _tmp30_;
	cairo_t* _tmp37_;
	GdkRGBA _tmp38_;
	cairo_t* _tmp39_;
	cairo_t* _tmp40_;
	cairo_t* _tmp41_;
	cairo_t* _tmp42_;
	GdkRGBA _tmp43_;
	cairo_t* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	gint _tmp48_;
	cairo_t* _tmp49_;
	gint _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	cairo_t* _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	cairo_t* _tmp59_;
	gint _tmp60_;
	gint _tmp61_;
	gint _tmp62_;
	gint _tmp63_;
	cairo_t* _tmp64_;
	cairo_t* _tmp65_;
	cairo_t* _tmp66_;
	GdkRGBA _tmp67_;
	cairo_t* _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	cairo_t* _tmp73_;
	gint _tmp74_;
	gint _tmp75_;
	gint _tmp76_;
	gint _tmp77_;
	cairo_t* _tmp78_;
	gint _tmp79_;
	gint _tmp80_;
	gint _tmp81_;
	gint _tmp82_;
	cairo_t* _tmp83_;
	gint _tmp84_;
	gint _tmp85_;
	gint _tmp86_;
	gint _tmp87_;
	cairo_t* _tmp88_;
	cairo_t* _tmp89_;
	GdkPixbuf* drawn_pb = NULL;
	cairo_surface_t* _tmp90_;
	cairo_surface_t* _tmp91_;
	cairo_surface_t* _tmp92_;
	GdkPixbuf* _tmp93_;
	GdkScreen* _tmp94_;
	GdkDisplay* _tmp95_;
	GdkCursor* _tmp96_;
	GdkEvent* events = NULL;
	GdkEvent* _tmp97_;
	GdkSeat* _tmp98_;
	GdkWindow* _tmp99_;
	GdkCursor* _tmp100_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = gdk_display_get_default_seat (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	manager = _tmp2_;
	_tmp3_ = manager;
	_tmp4_ = gdk_seat_get_pointer (_tmp3_);
	gdk_device_get_position (_tmp4_, NULL, &_tmp5_, &_tmp6_);
	px = _tmp5_;
	py = _tmp6_;
	_tmp7_ = spice_picker_window_get_zoomlevel (self);
	_tmp8_ = _tmp7_;
	radius = (SPICE_PICKER_WINDOW_SNAPSIZE * _tmp8_) / 2;
	_tmp9_ = spice_picker_window_snap (self, px - (SPICE_PICKER_WINDOW_SNAPSIZE / 2), py - (SPICE_PICKER_WINDOW_SNAPSIZE / 2), SPICE_PICKER_WINDOW_SNAPSIZE, SPICE_PICKER_WINDOW_SNAPSIZE);
	latest_pb = _tmp9_;
	_tmp10_ = latest_pb;
	_tmp11_ = spice_picker_window_get_zoomlevel (self);
	_tmp12_ = _tmp11_;
	_tmp13_ = spice_picker_window_get_zoomlevel (self);
	_tmp14_ = _tmp13_;
	_tmp15_ = gdk_pixbuf_scale_simple (_tmp10_, (SPICE_PICKER_WINDOW_SNAPSIZE * _tmp12_) + (SPICE_PICKER_WINDOW_SHADOW_WIDTH * 2), (SPICE_PICKER_WINDOW_SNAPSIZE * _tmp14_) + (SPICE_PICKER_WINDOW_SHADOW_WIDTH * 2), GDK_INTERP_NEAREST);
	scaled_pb = _tmp15_;
	_tmp16_ = spice_picker_window_get_zoomlevel (self);
	_tmp17_ = _tmp16_;
	_tmp18_ = spice_picker_window_get_zoomlevel (self);
	_tmp19_ = _tmp18_;
	_tmp20_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, (SPICE_PICKER_WINDOW_SNAPSIZE * _tmp17_) + (SPICE_PICKER_WINDOW_SHADOW_WIDTH * 2), (SPICE_PICKER_WINDOW_SNAPSIZE * _tmp19_) + (SPICE_PICKER_WINDOW_SHADOW_WIDTH * 2));
	base_surface = _tmp20_;
	_tmp21_ = base_surface;
	_tmp22_ = cairo_create (_tmp21_);
	base_context = _tmp22_;
	_tmp23_ = base_context;
	cairo_arc (_tmp23_, (gdouble) (radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH), (gdouble) (radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH), (gdouble) radius, (gdouble) 0, 2 * G_PI);
	_tmp24_ = base_context;
	_tmp25_ = scaled_pb;
	gdk_cairo_set_source_pixbuf (_tmp24_, _tmp25_, (gdouble) 0, (gdouble) 0);
	_tmp26_ = base_context;
	cairo_save (_tmp26_);
	_tmp27_ = base_context;
	cairo_clip_preserve (_tmp27_);
	_tmp28_ = base_context;
	cairo_paint (_tmp28_);
	_tmp29_ = base_context;
	cairo_restore (_tmp29_);
	shadow_alpha = 0.6;
	_tmp30_ = base_context;
	cairo_set_line_width (_tmp30_, (gdouble) 1);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp31_ = FALSE;
			_tmp31_ = TRUE;
			while (TRUE) {
				cairo_t* _tmp33_;
				GdkRGBA shadow_color = {0};
				cairo_t* _tmp34_;
				GdkRGBA _tmp35_;
				cairo_t* _tmp36_;
				if (!_tmp31_) {
					gint _tmp32_;
					_tmp32_ = i;
					i = _tmp32_ + 1;
				}
				_tmp31_ = FALSE;
				if (!(i <= SPICE_PICKER_WINDOW_SHADOW_WIDTH)) {
					break;
				}
				_tmp33_ = base_context;
				cairo_arc (_tmp33_, (gdouble) (radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH), (gdouble) (radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH), (gdouble) ((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) - i), (gdouble) 0, 2 * G_PI);
				memset (&shadow_color, 0, sizeof (GdkRGBA));
				gdk_rgba_parse (&shadow_color, SPICE_PICKER_WINDOW_dark_border_color_string);
				shadow_color.alpha = shadow_alpha / (((SPICE_PICKER_WINDOW_SHADOW_WIDTH - i) + 1) * ((SPICE_PICKER_WINDOW_SHADOW_WIDTH - i) + 1));
				_tmp34_ = base_context;
				_tmp35_ = shadow_color;
				gdk_cairo_set_source_rgba (_tmp34_, &_tmp35_);
				_tmp36_ = base_context;
				cairo_stroke (_tmp36_);
			}
		}
	}
	_tmp37_ = base_context;
	_tmp38_ = self->priv->bright_border_color;
	gdk_cairo_set_source_rgba (_tmp37_, &_tmp38_);
	_tmp39_ = base_context;
	cairo_arc (_tmp39_, (gdouble) (radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH), (gdouble) (radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH), (gdouble) (radius - 1), (gdouble) 0, 2 * G_PI);
	_tmp40_ = base_context;
	cairo_stroke (_tmp40_);
	_tmp41_ = base_context;
	cairo_set_line_width (_tmp41_, (gdouble) 1);
	_tmp42_ = base_context;
	_tmp43_ = self->priv->dark_border_color;
	gdk_cairo_set_source_rgba (_tmp42_, &_tmp43_);
	_tmp44_ = base_context;
	_tmp45_ = spice_picker_window_get_zoomlevel (self);
	_tmp46_ = _tmp45_;
	_tmp47_ = spice_picker_window_get_zoomlevel (self);
	_tmp48_ = _tmp47_;
	cairo_move_to (_tmp44_, (gdouble) ((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) - _tmp46_), (gdouble) ((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) - _tmp48_));
	_tmp49_ = base_context;
	_tmp50_ = spice_picker_window_get_zoomlevel (self);
	_tmp51_ = _tmp50_;
	_tmp52_ = spice_picker_window_get_zoomlevel (self);
	_tmp53_ = _tmp52_;
	cairo_line_to (_tmp49_, (gdouble) ((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) + _tmp51_), (gdouble) ((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) - _tmp53_));
	_tmp54_ = base_context;
	_tmp55_ = spice_picker_window_get_zoomlevel (self);
	_tmp56_ = _tmp55_;
	_tmp57_ = spice_picker_window_get_zoomlevel (self);
	_tmp58_ = _tmp57_;
	cairo_line_to (_tmp54_, (gdouble) ((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) + _tmp56_), (gdouble) ((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) + _tmp58_));
	_tmp59_ = base_context;
	_tmp60_ = spice_picker_window_get_zoomlevel (self);
	_tmp61_ = _tmp60_;
	_tmp62_ = spice_picker_window_get_zoomlevel (self);
	_tmp63_ = _tmp62_;
	cairo_line_to (_tmp59_, (gdouble) ((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) - _tmp61_), (gdouble) ((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) + _tmp63_));
	_tmp64_ = base_context;
	cairo_close_path (_tmp64_);
	_tmp65_ = base_context;
	cairo_stroke (_tmp65_);
	_tmp66_ = base_context;
	_tmp67_ = self->priv->bright_border_color;
	gdk_cairo_set_source_rgba (_tmp66_, &_tmp67_);
	_tmp68_ = base_context;
	_tmp69_ = spice_picker_window_get_zoomlevel (self);
	_tmp70_ = _tmp69_;
	_tmp71_ = spice_picker_window_get_zoomlevel (self);
	_tmp72_ = _tmp71_;
	cairo_move_to (_tmp68_, (gdouble) (((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) - _tmp70_) + 1), (gdouble) (((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) - _tmp72_) + 1));
	_tmp73_ = base_context;
	_tmp74_ = spice_picker_window_get_zoomlevel (self);
	_tmp75_ = _tmp74_;
	_tmp76_ = spice_picker_window_get_zoomlevel (self);
	_tmp77_ = _tmp76_;
	cairo_line_to (_tmp73_, (gdouble) (((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) + _tmp75_) - 1), (gdouble) (((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) - _tmp77_) + 1));
	_tmp78_ = base_context;
	_tmp79_ = spice_picker_window_get_zoomlevel (self);
	_tmp80_ = _tmp79_;
	_tmp81_ = spice_picker_window_get_zoomlevel (self);
	_tmp82_ = _tmp81_;
	cairo_line_to (_tmp78_, (gdouble) (((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) + _tmp80_) - 1), (gdouble) (((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) + _tmp82_) - 1));
	_tmp83_ = base_context;
	_tmp84_ = spice_picker_window_get_zoomlevel (self);
	_tmp85_ = _tmp84_;
	_tmp86_ = spice_picker_window_get_zoomlevel (self);
	_tmp87_ = _tmp86_;
	cairo_line_to (_tmp83_, (gdouble) (((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) - _tmp85_) + 1), (gdouble) (((radius + SPICE_PICKER_WINDOW_SHADOW_WIDTH) + _tmp87_) - 1));
	_tmp88_ = base_context;
	cairo_close_path (_tmp88_);
	_tmp89_ = base_context;
	cairo_stroke (_tmp89_);
	_tmp90_ = base_surface;
	_tmp91_ = base_surface;
	_tmp92_ = base_surface;
	_tmp93_ = gdk_pixbuf_get_from_surface (_tmp90_, 0, 0, cairo_image_surface_get_width (_tmp91_), cairo_image_surface_get_height (_tmp92_));
	drawn_pb = _tmp93_;
	_tmp94_ = gtk_window_get_screen ((GtkWindow*) self);
	_tmp95_ = gdk_screen_get_display (_tmp94_);
	_tmp96_ = gdk_cursor_new_from_pixbuf (_tmp95_, drawn_pb, gdk_pixbuf_get_width (drawn_pb) / 2, gdk_pixbuf_get_height (drawn_pb) / 2);
	_g_object_unref0 (self->priv->magnifier);
	self->priv->magnifier = _tmp96_;
	_tmp97_ = gdk_event_new ((GDK_BUTTON_PRESS | GDK_MOTION_NOTIFY) | GDK_SCROLL);
	events = _tmp97_;
	_tmp98_ = manager;
	_tmp99_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp100_ = self->priv->magnifier;
	gdk_seat_grab (_tmp98_, _tmp99_, GDK_SEAT_CAPABILITY_ALL, TRUE, _tmp100_, events, NULL, NULL);
	__vala_GdkEvent_free0 (events);
	_g_object_unref0 (drawn_pb);
	_cairo_destroy0 (base_context);
	_cairo_surface_destroy0 (base_surface);
	_g_object_unref0 (scaled_pb);
	_g_object_unref0 (latest_pb);
	_g_object_unref0 (manager);
}

GdkPixbuf*
spice_picker_window_snap (SpicePickerWindow* self,
                          gint x,
                          gint y,
                          gint w,
                          gint h)
{
	GdkWindow* root = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkPixbuf* screenshot = NULL;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gdk_get_default_root_window ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	root = _tmp1_;
	_tmp2_ = gdk_pixbuf_get_from_window (root, x, y, w, h);
	screenshot = _tmp2_;
	result = screenshot;
	_g_object_unref0 (root);
	return result;
}

static gboolean
spice_picker_window_real_key_press_event (GtkWidget* base,
                                          GdkEventKey* e)
{
	SpicePickerWindow * self;
	gboolean result;
	self = (SpicePickerWindow*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->keyval == GDK_KEY_Escape) {
		g_signal_emit (self, spice_picker_window_signals[SPICE_PICKER_WINDOW_CANCELLED_SIGNAL], 0);
	}
	result = TRUE;
	return result;
}

void
spice_picker_window_get_color_at (SpicePickerWindow* self,
                                  gint x,
                                  gint y,
                                  GdkRGBA* result)
{
	GdkWindow* root = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkPixbuf* pixbuf = NULL;
	GdkWindow* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkRGBA _tmp33_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = gdk_get_default_root_window ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	root = _tmp1_;
	_tmp2_ = root;
	_tmp3_ = gdk_pixbuf_get_from_window (_tmp2_, x, y, 1, 1);
	pixbuf = _tmp3_;
	_tmp4_ = pixbuf;
	if (_tmp4_ != NULL) {
		guint8 red = 0U;
		GdkPixbuf* _tmp5_;
		guint8* _tmp6_;
		guint8 _tmp7_;
		guint8 green = 0U;
		GdkPixbuf* _tmp8_;
		guint8* _tmp9_;
		guint8 _tmp10_;
		guint8 blue = 0U;
		GdkPixbuf* _tmp11_;
		guint8* _tmp12_;
		guint8 _tmp13_;
		GdkRGBA color = {0};
		gchar* spec = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		const gchar* _tmp32_;
		_tmp5_ = pixbuf;
		_tmp6_ = gdk_pixbuf_get_pixels (_tmp5_);
		_tmp7_ = _tmp6_[0];
		red = _tmp7_;
		_tmp8_ = pixbuf;
		_tmp9_ = gdk_pixbuf_get_pixels (_tmp8_);
		_tmp10_ = _tmp9_[1];
		green = _tmp10_;
		_tmp11_ = pixbuf;
		_tmp12_ = gdk_pixbuf_get_pixels (_tmp11_);
		_tmp13_ = _tmp12_[2];
		blue = _tmp13_;
		memset (&color, 0, sizeof (GdkRGBA));
		_tmp14_ = g_strdup_printf ("%hhu", red);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strconcat ("rgb(", _tmp15_, NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strconcat (_tmp17_, ",", NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strdup_printf ("%hhu", green);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strconcat (_tmp19_, _tmp21_, NULL);
		_tmp23_ = _tmp22_;
		_tmp24_ = g_strconcat (_tmp23_, ",", NULL);
		_tmp25_ = _tmp24_;
		_tmp26_ = g_strdup_printf ("%hhu", blue);
		_tmp27_ = _tmp26_;
		_tmp28_ = g_strconcat (_tmp25_, _tmp27_, NULL);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_strconcat (_tmp29_, ")", NULL);
		_tmp31_ = _tmp30_;
		_g_free0 (_tmp29_);
		_g_free0 (_tmp27_);
		_g_free0 (_tmp25_);
		_g_free0 (_tmp23_);
		_g_free0 (_tmp21_);
		_g_free0 (_tmp19_);
		_g_free0 (_tmp17_);
		_g_free0 (_tmp15_);
		spec = _tmp31_;
		_tmp32_ = spec;
		if (gdk_rgba_parse (&color, _tmp32_)) {
			*result = color;
			_g_free0 (spec);
			_g_object_unref0 (pixbuf);
			_g_object_unref0 (root);
			return;
		} else {
			g_warning ("PickerWindow.vala:257: Parse of pixel rgb values failed.");
		}
		_g_free0 (spec);
	}
	g_warning ("PickerWindow.vala:262: Gdk.pixbuf_get_from_window failed");
	memset (&_tmp33_, 0, sizeof (GdkRGBA));
	*result = _tmp33_;
	_g_object_unref0 (pixbuf);
	_g_object_unref0 (root);
	return;
}

static void
spice_picker_window_real_show_all (GtkWidget* base)
{
	SpicePickerWindow * self;
	GdkSeat* manager = NULL;
	GdkDisplay* _tmp0_;
	GdkSeat* _tmp1_;
	GdkSeat* _tmp2_;
	GdkWindow* window = NULL;
	GdkWindow* _tmp3_;
	GdkWindow* _tmp4_;
	GdkEvent* events = NULL;
	GdkEvent* _tmp5_;
	GdkGrabStatus status = 0;
	GdkSeat* _tmp6_;
	GdkWindow* _tmp7_;
	GdkWindow* _tmp8_;
	GdkDisplay* _tmp9_;
	GdkCursor* _tmp10_;
	GdkCursor* _tmp11_;
	GdkEvent* _tmp12_;
	GdkGrabStatus _tmp13_;
	self = (SpicePickerWindow*) base;
	GTK_WIDGET_CLASS (spice_picker_window_parent_class)->show_all ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_WIDGETS_TYPE_COMPOSITED_WINDOW, GraniteWidgetsCompositedWindow));
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = gdk_display_get_default_seat (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	manager = _tmp2_;
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	window = _tmp4_;
	_tmp5_ = gdk_event_new ((GDK_BUTTON_PRESS | GDK_MOTION_NOTIFY) | GDK_SCROLL);
	events = _tmp5_;
	_tmp6_ = manager;
	_tmp7_ = window;
	_tmp8_ = window;
	_tmp9_ = gdk_window_get_display (_tmp8_);
	_tmp10_ = gdk_cursor_new_for_display (_tmp9_, GDK_CROSSHAIR);
	_tmp11_ = _tmp10_;
	_tmp12_ = events;
	_tmp13_ = gdk_seat_grab (_tmp6_, _tmp7_, GDK_SEAT_CAPABILITY_ALL, TRUE, _tmp11_, _tmp12_, NULL, NULL);
	_g_object_unref0 (_tmp11_);
	status = _tmp13_;
	if (status != GDK_GRAB_SUCCESS) {
		GdkSeat* _tmp14_;
		_tmp14_ = manager;
		gdk_seat_ungrab (_tmp14_);
	}
	spice_picker_window_set_magnifier_cursor (self);
	__vala_GdkEvent_free0 (events);
	_g_object_unref0 (window);
	_g_object_unref0 (manager);
}

void
spice_picker_window_close (SpicePickerWindow* self)
{
	GdkWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	gdk_window_set_cursor (_tmp0_, NULL);
	gtk_window_close ((GtkWindow*) G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_WIDGETS_TYPE_COMPOSITED_WINDOW, GraniteWidgetsCompositedWindow));
}

gint
spice_picker_window_get_zoomlevel (SpicePickerWindow* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = spice_picker_window__zoom_level;
	return result;
}

void
spice_picker_window_set_zoomlevel (SpicePickerWindow* self,
                                   gint value)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (value >= SPICE_PICKER_WINDOW_MIN_ZOOM_LEVEL) {
		_tmp0_ = value <= SPICE_PICKER_WINDOW_MAX_ZOOM_LEVEL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		spice_picker_window__zoom_level = value;
		spice_picker_window_set_magnifier_cursor (self);
	}
	g_object_notify_by_pspec ((GObject *) self, spice_picker_window_properties[SPICE_PICKER_WINDOW_ZOOMLEVEL_PROPERTY]);
}

static GObject *
spice_picker_window_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SpicePickerWindow * self;
	parent_class = G_OBJECT_CLASS (spice_picker_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SPICE_TYPE_PICKER_WINDOW, SpicePickerWindow);
	g_object_set ((GtkWindow*) self, "type", GTK_WINDOW_POPUP, NULL);
	return obj;
}

static void
spice_picker_window_class_init (SpicePickerWindowClass * klass,
                                gpointer klass_data)
{
	spice_picker_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SpicePickerWindow_private_offset);
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) spice_picker_window_real_button_release_event;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) spice_picker_window_real_draw;
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) spice_picker_window_real_motion_notify_event;
	((GtkWidgetClass *) klass)->scroll_event = (gboolean (*) (GtkWidget*, GdkEventScroll*)) spice_picker_window_real_scroll_event;
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) spice_picker_window_real_key_press_event;
	((GtkWidgetClass *) klass)->show_all = (void (*) (GtkWidget*)) spice_picker_window_real_show_all;
	G_OBJECT_CLASS (klass)->get_property = _vala_spice_picker_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_spice_picker_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = spice_picker_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = spice_picker_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPICE_PICKER_WINDOW_ZOOMLEVEL_PROPERTY, spice_picker_window_properties[SPICE_PICKER_WINDOW_ZOOMLEVEL_PROPERTY] = g_param_spec_int ("zoomlevel", "zoomlevel", "zoomlevel", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	spice_picker_window_signals[SPICE_PICKER_WINDOW_PICKED_SIGNAL] = g_signal_new ("picked", SPICE_TYPE_PICKER_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_rgba_get_type ());
	spice_picker_window_signals[SPICE_PICKER_WINDOW_CANCELLED_SIGNAL] = g_signal_new ("cancelled", SPICE_TYPE_PICKER_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	spice_picker_window_signals[SPICE_PICKER_WINDOW_MOVED_SIGNAL] = g_signal_new ("moved", SPICE_TYPE_PICKER_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_rgba_get_type ());
}

static void
spice_picker_window_instance_init (SpicePickerWindow * self,
                                   gpointer klass)
{
	self->priv = spice_picker_window_get_instance_private (self);
	memset (&self->priv->dark_border_color, 0, sizeof (GdkRGBA));
	memset (&self->priv->bright_border_color, 0, sizeof (GdkRGBA));
	self->priv->magnifier = NULL;
}

static void
spice_picker_window_finalize (GObject * obj)
{
	SpicePickerWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SPICE_TYPE_PICKER_WINDOW, SpicePickerWindow);
	_g_object_unref0 (self->priv->magnifier);
	G_OBJECT_CLASS (spice_picker_window_parent_class)->finalize (obj);
}

static GType
spice_picker_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SpicePickerWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) spice_picker_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SpicePickerWindow), 0, (GInstanceInitFunc) spice_picker_window_instance_init, NULL };
	GType spice_picker_window_type_id;
	spice_picker_window_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_COMPOSITED_WINDOW, "SpicePickerWindow", &g_define_type_info, 0);
	SpicePickerWindow_private_offset = g_type_add_instance_private (spice_picker_window_type_id, sizeof (SpicePickerWindowPrivate));
	return spice_picker_window_type_id;
}

GType
spice_picker_window_get_type (void)
{
	static volatile gsize spice_picker_window_type_id__once = 0;
	if (g_once_init_enter (&spice_picker_window_type_id__once)) {
		GType spice_picker_window_type_id;
		spice_picker_window_type_id = spice_picker_window_get_type_once ();
		g_once_init_leave (&spice_picker_window_type_id__once, spice_picker_window_type_id);
	}
	return spice_picker_window_type_id__once;
}

static void
_vala_spice_picker_window_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SpicePickerWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SPICE_TYPE_PICKER_WINDOW, SpicePickerWindow);
	switch (property_id) {
		case SPICE_PICKER_WINDOW_ZOOMLEVEL_PROPERTY:
		g_value_set_int (value, spice_picker_window_get_zoomlevel (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_spice_picker_window_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SpicePickerWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SPICE_TYPE_PICKER_WINDOW, SpicePickerWindow);
	switch (property_id) {
		case SPICE_PICKER_WINDOW_ZOOMLEVEL_PROPERTY:
		spice_picker_window_set_zoomlevel (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

gchar*
ext_rgba_to_css_rgb_string (ExtRGBA *self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	gchar* result;
	_tmp0_ = g_strdup_printf ("rgb(%i, %i, %i)", (gint) ((*self).red * 255), (gint) ((*self).green * 255), (gint) ((*self).blue * 255));
	s = _tmp0_;
	result = s;
	return result;
}

ExtRGBA*
ext_rgba_dup (const ExtRGBA* self)
{
	ExtRGBA* dup;
	dup = g_new0 (ExtRGBA, 1);
	memcpy (dup, self, sizeof (ExtRGBA));
	return dup;
}

void
ext_rgba_free (ExtRGBA* self)
{
	g_free (self);
}

static GType
ext_rgba_get_type_once (void)
{
	GType ext_rgba_type_id;
	ext_rgba_type_id = g_boxed_type_register_static ("ExtRGBA", (GBoxedCopyFunc) ext_rgba_dup, (GBoxedFreeFunc) ext_rgba_free);
	return ext_rgba_type_id;
}

GType
ext_rgba_get_type (void)
{
	static volatile gsize ext_rgba_type_id__once = 0;
	if (g_once_init_enter (&ext_rgba_type_id__once)) {
		GType ext_rgba_type_id;
		ext_rgba_type_id = ext_rgba_get_type_once ();
		g_once_init_leave (&ext_rgba_type_id__once, ext_rgba_type_id);
	}
	return ext_rgba_type_id__once;
}

